Attribute VB_Name = "modPublic"
Option Explicit

'constants for data transfer in multiplayer games
Public Const strCantMakeWord As String = "CantMakeWord"
Public Const strMadeWord As String = "MadeWord"
Public Const strYourGo As String = "YourTurn"
Public Const strIAm As String = "IAm"
Public Const strWhoRU As String = "Who?"
Public Const strMessage As String = "Msg"
Public Const strLeaving As String = "Leaving"
Public Const strMove As String = "Move"
Public Const strLetters As String = "Letters"
Public Const strCounterChange As String = "CounterChange"
Public Const strGameStart As String = "GameStarted"
Public Const strNewGuy As String = "NewPlayer"

'colour constants
Public Const lngPurple As Long = 16711828
Public Const lngBlack As Long = 0
Public Const lngWhite As Long = 16777215
Public Const lngGreen As Long = 48896
Public Const lngRed As Long = 255
Public Const lngBlue As Long = 16711680
Public Const lngYellow As Long = 65535


'constant for data deliminator
Public Const strCheck As String = "||" '<----- can you read it?

'constant for data checking
Public Const strDelim As String = ""

'variable to hold the player's name
Public strPlayerName As String
Public lngPlayerColour As Long

'variable to tell us whether it's a multiplayer game or not
Public intMultiPlayer As Integer

Public Sub ChangeCounter(intPlayer As Integer, intNew As Integer)
    frmSingleMulti.imgPlayerCounter(intPlayer).Picture = frmSpellbound.imlCounters.ListImages.Item(intNew).Picture
    frmSingleMulti.imgPlayerCounter(intPlayer).Tag = intNew
End Sub

Public Sub TellAboutCounterMove(intIndex As Integer)
    If intMultiPlayer = 1 Then  'player is a server
        ServerBroad strMove & strDelim & strPlayerName & strDelim & intIndex, -1
    Else
        ClientCast strMove & strDelim & strPlayerName & strDelim & intIndex
    End If
End Sub

Public Sub Log(strData As String, Optional lngColour As Long = lngBlack, Optional bolBold As Boolean = True, Optional bolItalics As Boolean = False)
    frmSpellbound.rtbHistory.SelStart = Len(frmSpellbound.rtbHistory.Text)  'scroll the textbox
    frmSpellbound.rtbHistory.SelText = strData & vbCrLf    'insert the text
    frmSpellbound.rtbHistory.SelStart = Len(frmSpellbound.rtbHistory.Text) - Len(strData) - 2   'set the start of the selection
    frmSpellbound.rtbHistory.SelLength = Len(strData) 'select the data
    frmSpellbound.rtbHistory.SelColor = lngColour    'set the colour
    frmSpellbound.rtbHistory.SelBold = bolBold    'set the bold
    frmSpellbound.rtbHistory.SelItalic = bolItalics   'set the italics
    frmSpellbound.rtbHistory.SelStart = Len(frmSpellbound.rtbHistory.Text)  'scroll the textbox
End Sub

Public Function NameToIndex(strName As String) As Integer
    Dim intX As Integer
    For intX = 0 To 3   'for each of the players
        If frmSingleMulti.lblPlayerName(intX).Caption = strName Then   'we've found the name
            NameToIndex = intX
            Exit Function
        End If
    Next intX
End Function

Public Sub ServerCast(strData As String, intIndex As Integer)
    If frmSpellbound.wskServer(intIndex).State = sckConnected Then
        Log strData, lngGreen
        frmSpellbound.wskServer(intIndex).SendData strCheck & strDelim & strData
        Dim intX As Integer
        For intX = 1 To 32767
            DoEvents
        Next intX
    End If
End Sub

Public Sub ServerBroad(strData As String, intNotIndex As Integer)
    Dim intX As Integer
    For intX = frmSpellbound.wskServer.lBound To frmSpellbound.wskServer.UBound    'for each of the server ports
        If Not intX = intNotIndex Then  'if we're not sending to the 'not index' ie the person who sent us the data
            ServerCast strData, intX
        End If
    Next intX
End Sub

Public Sub ClientCast(strData As String)
    If frmSpellbound.wskClient.State = sckConnected Then
        Log strData, lngGreen
        frmSpellbound.wskClient.SendData strCheck & strDelim & strData
        DoEvents
    End If
End Sub

Public Function GetNextFreePlayer() As Integer
    Dim intX As Integer
    For intX = 1 To 3
        Select Case frmSingleMulti.lblPlayerName(intX).Caption
            Case vbNullString, "Player 1", "Player 2", "Player 3"
                GetNextFreePlayer = intX
                Exit Function
        End Select
    Next intX
End Function

Public Sub TellAboutCounterChange(strPlayerName As String, strNewCounter As String)
    If intMultiPlayer = 1 Then  'player is a server
        ServerBroad strCounterChange & strDelim & strPlayerName & strDelim & strNewCounter, -1
    Else
        ClientCast strCounterChange & strDelim & strPlayerName & strDelim & strNewCounter
    End If
End Sub

Public Function GetRandomLetter() As Integer
    Dim intRnd As Integer
    Do
        Randomize
        intRnd = Int(Rnd * 75)
    Loop Until Not intRnd = 0 And Not intRnd = 15 And Not intRnd = 18 And Not intRnd = 29 And Not intRnd = 35 And Not intRnd = 46 And Not intRnd = 49 And Not intRnd = 64
    GetRandomLetter = intRnd
End Function























'zfgkdshgdf
